using System;
using SC = System.Collections;
using SD = System.Data;
using SWF = System.Windows.Forms;

namespace BusinessTier
{

	public class BankCustomers
	{

		private DataAccessTier.DataAccess  dataStore;

		//
		// constructor
		//
		public BankCustomers()
		{
			string  sConnect;
			
			// SQL Server
			sConnect = string.Format("Server={0};Database={1};{2}",
				"localhost", 
				"Sales",
				"Integrated Security=SSPI");  // uid=sa;pwd=???

			// MS Access
//			sConnect = string.Format("Provider={0};Data Source={1}{2}",
//				"Microsoft.Jet.OLEDB.4.0;",
//				System.AppDomain.CurrentDomain.BaseDirectory,
//				"Sales.mdb");

			this.dataStore = new DataAccessTier.DataAccess(sConnect);
		}

		//
		// get all the customers
		//
		public SC.ArrayList Get()
		{
			SD.DataSet    ds;
			SC.ArrayList  customers = new SC.ArrayList();
			BankCustomer  c;

			// 
			// SQL query...
			//
			string  sql;

			sql = "Select * From Customers Order By LastName Asc, FirstName Asc;";

			// SWF.MessageBox.Show(sql);

			//
			// now execute the SQL...
			//
			ds = this.dataStore.Retrieve(sql);

			foreach(SD.DataRow row in ds.Tables["Table"].Rows)
			{
				c = new BankCustomer(System.Convert.ToInt32(row["CID"]),
					row["FirstName"].ToString(),
					row["LastName"].ToString(),
					System.Convert.ToDecimal(row["AcctBalance"]));

				customers.Add(c);
			}

			return customers;
		}

		//
		// delete this one customer
		//
		public void Delete(BankCustomer bc)
		{
			//
			// be sure to escape values when working with text fields!
			//
			string  sql;

			sql = string.Format("Delete from Customers where FirstName='{0}' and LastName='{1}';",
					Validation.ProperlyEscape(bc.FirstName),
					Validation.ProperlyEscape(bc.LastName));

			// SWF.MessageBox.Show(sql);

			this.dataStore.Delete(sql);
		}

	}//class
}//namespace
