using System;
using SWF = System.Windows.Forms;
using RE = System.Text.RegularExpressions.Regex;

namespace BusinessTier
{

	public class Validation
	{

		public static bool isProperlyEscaped(string s)
		{
			string  pattern;
			pattern = "^([^']|(''))*$";

			return RE.Match(s, pattern).Success;
		}

		public static string ProperlyEscape(string s)
		{
			if (isProperlyEscaped(s))
				return s;
			else
				return s.Replace("'", "''");
		}

		public static void IsInteger(object sender, System.ComponentModel.CancelEventArgs e)
		{
			SWF.TextBox  txt;
			txt = (SWF.TextBox) sender;

			try
			{
				int.Parse(txt.Text);
			}
			catch(FormatException)
			{
				SWF.MessageBox.Show("Please enter a numeric value.", "Bank Customer App");
				e.Cancel = true;  // cancel validation, returns focus
			}
			catch(OverflowException)
			{
				SWF.MessageBox.Show("Please enter an integer in the range " + int.MinValue + " ... " + int.MaxValue, "Bank Customer App");
				e.Cancel = true;  // cancel validation, returns focus
			}
			catch(Exception ex)
			{
				SWF.MessageBox.Show("Unknown error: " + ex.Message, "Bank Customer App");
				e.Cancel = true;  // cancel validation, returns focus
			}
		}
	
	}//class
}//namespace
